export declare class Heap {
    arr: number[];
    defaultCompare: (a: any, b: any) => boolean;
    compare: any;
    constructor(compare: Function | undefined);
    /**
    * 堆中元素数量
    */
    get size(): number;
    /**
     * 根据可迭代对象生成堆
     * @param {*} data iterable 对象
     * @param {*} compare
     */
    static heapify(data: any, compare: Function | undefined): Heap;
    /**
    * 入队
    */
    push(item: any): void;
    /**
    * 向上调整
    */
    up(k: any): void;
    /**
    * 交换位置
    */
    swap(i: any, j: any): void;
    /**
    * 左孩子
    */
    left(k: any): number;
    /**
    * 右孩子
    */
    right(k: any): number;
    /**
    * 双亲
    */
    parent(k: any): number;
    /**
     * 向下调整
     * @param {int} k
     */
    down(k: any): void;
    /**
    * 返回优先级最高元素，出队
    */
    pop(): any;
    /**
    * 返回优先级最高元素，但不出队
    */
    peek(): any;
}
//# sourceMappingURL=heap.d.ts.map