var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { Heap } from "./heap";
export var getItemByValue = function (list, value, valueField) {
    var _a;
    if (valueField === void 0) { valueField = "value"; }
    return (_a = list.find(function (item) { return item[valueField] === value; })) !== null && _a !== void 0 ? _a : {};
};
// 分组
export function groupByNames(arr, // 数据
option) {
    var args = []; // 分组参数,string为单字段分组,string[]为组合分组
    for (var _i = 2 // 分组参数,string为单字段分组,string[]为组合分组
    ; _i < arguments.length // 分组参数,string为单字段分组,string[]为组合分组
    ; _i++ // 分组参数,string为单字段分组,string[]为组合分组
    ) {
        args[_i - 2] = arguments[_i]; // 分组参数,string为单字段分组,string[]为组合分组
    }
    if (!arr.length)
        return arr;
    // 默认配置
    var defaultOption = {
        resFn: function (key, value) {
            return {
                label: Array.isArray(key)
                    ? key
                        .map(function (item) { return item !== null && item !== void 0 ? item : "--"; })
                        .join(",")
                    : key,
                children: value,
            };
        },
        isDeleteKey: false,
        defaultValue: null,
        leafResFn: function (data) {
            return data;
        },
        isSkipCheck: false
    };
    option = __assign(__assign({}, defaultOption), option);
    var _a = option, resFn = _a.resFn, defaultValue = _a.defaultValue, isDeleteKey = _a.isDeleteKey, leafResFn = _a.leafResFn, isSkipCheck = _a.isSkipCheck;
    // 递归指针
    var i = 0;
    // 递归函数
    var dp = function (arr, name) {
        // 生成叶子节点
        if (!name)
            return leafResFn
                ? arr.map(function (item) {
                    var leaf = leafResFn(item, i);
                    !leaf && !isSkipCheck && console.warn("Warning:groupByNames\u65B9\u6CD5\u7684\u53C2\u6570option.leafResponseFn\u6CA1\u6709\u8FD4\u56DE\u503C");
                    return leaf;
                })
                : arr;
        // 通过map实现分组
        var map = new Map();
        arr.forEach(function (item) {
            var v = Array.isArray(name)
                ? JSON.stringify(name.map(function (n) { return item[n]; }))
                : item[name];
            var o = map.get(v !== null && v !== void 0 ? v : defaultValue);
            var dv = v !== null && v !== void 0 ? v : defaultValue;
            if (dv !== null) {
                v && isDeleteKey && Array.isArray(name)
                    ? name.forEach(function (names) { return delete item[names]; })
                    : delete item[name];
                o
                    ? o.push(item)
                    : map.set(dv, [item]);
            }
        });
        // 递归生成每个非叶子节点
        var data = __spreadArray([], __read(map), false).map(function (item) {
            var _a = __read(item, 2), k = _a[0], v = _a[1];
            var d = resFn(Array.isArray(name) ? JSON.parse(k) : k, dp(v, args[++i]), i);
            i--;
            !d && !isSkipCheck && console.warn("Warning:groupByNames\u65B9\u6CD5\u7684\u53C2\u6570option.fn\u6CA1\u6709\u8FD4\u56DE\u503C");
            return d;
        });
        return data;
    };
    return dp(arr, args[i]);
}
// 数据合并
export function jsonMerge(a, //被合入数据
b, //合入数据,若有相同字段b会覆盖a
aname, //a的aname与b的bname字段匹配
bname) {
    if (a === void 0) { a = []; }
    if (b === void 0) { b = []; }
    var bn = bname !== null && bname !== void 0 ? bname : aname;
    var map = new Map();
    b.forEach(function (item) {
        map.set(item[bn], item);
    });
    return a.map(function (item) {
        return __assign(__assign({}, item), map.get(item[aname]));
    });
}
// 部分数据合并
export function jsonMergebyField(a, //被合入数据
b, //合入数据,若有相同字段b会覆盖a
aname, //a的aname与b的bname字段匹配
field, bname) {
    var mergeFn = function (a, b) {
        if (!Array.isArray(field)) {
            if (b === null || b === void 0 ? void 0 : b[field])
                a[field] = b === null || b === void 0 ? void 0 : b[field];
        }
        else {
            field.forEach(function (f) {
                if (b === null || b === void 0 ? void 0 : b[f])
                    a[f] = b === null || b === void 0 ? void 0 : b[f];
            });
        }
        ;
        return a;
    };
    return jsonMergebyFn(a, b, aname, mergeFn, bname);
}
// 自定义的数据合并
export function jsonMergebyFn(a, //被合入数据
b, //合入数据,若有相同字段b会覆盖a
aname, //a的aname与b的bname字段匹配
mergeFn, bname) {
    if (a === void 0) { a = []; }
    if (b === void 0) { b = []; }
    var bn = bname !== null && bname !== void 0 ? bname : aname;
    var map = new Map();
    b.forEach(function (item) {
        map.set(item[bn], item);
    });
    return a.map(function (item) {
        return mergeFn(item, map.get(item[aname]));
    });
}
export function uniqueJsonByKey(list, option) {
    var defaultOption = {
        mode: "default",
        keyField: "key",
        getKey: function (item) {
            var _a;
            return item === null || item === void 0 ? void 0 : item[(_a = option.keyField) !== null && _a !== void 0 ? _a : "key"];
        }
    };
    option = __assign(__assign({}, defaultOption), option);
    var _a = option, mode = _a.mode, getKey = _a.getKey;
    var filter = function (list) {
        var map = new Map();
        var outputArr = [];
        list.forEach(function (item) {
            var o = map.get(getKey(item));
            !o && (map.set(getKey(item), item),
                outputArr.push(item));
        });
        return outputArr;
    };
    return mode === "reverse" ? filter(list.reverse()).reverse() : filter(list);
}
export function deepClone(list) {
    var getCloneObj = function (item) {
        return typeof item === "object" ? deepClone(item) : item;
    };
    // console.log(list)
    // console.log(typeof list)
    if (Array.isArray(list))
        return list.map(function (item) { return getCloneObj(item); });
    else if (list instanceof Map) {
        return new Map(__spreadArray([], __read(list), false).map(function (item) {
            item[1] = getCloneObj(item[1]);
            return item;
        }));
    }
    else if (list instanceof Set) {
        return new Set(__spreadArray([], __read(list), false));
    }
    else {
        var allKeys = Reflect.ownKeys(list);
        return allKeys.reduce(function (a, b) {
            var _a;
            return __assign(__assign({}, a), (_a = {}, _a[b] = getCloneObj(Reflect.get(list, b)), _a));
        }, {});
    }
}
export function getTopN(list, compare, n) {
    var heap = Heap.heapify(list, compare);
    var size = heap.size;
    var result = [];
    for (var i = 0; i < Math.min(n, size); i++) {
        result.push(heap.pop());
    }
    return result;
}
//# sourceMappingURL=json.js.map