var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { deepClone } from "./json";
export function toTree(arr, //数据
option //配置
) {
    //默认配置
    option = __assign({ parentIdField: "parentId", idField: "id", rootId: "0", childrenField: "children", leafResFn: function (data, layer) {
            return __assign(__assign({}, data), { isLeaf: true });
        }, resFn: function (data, layer) {
            return __assign(__assign({}, data), { layer: layer });
        } }, option);
    var _a = option, parentIdField = _a.parentIdField, idField = _a.idField, rootId = _a.rootId, childrenField = _a.childrenField, leafResFn = _a.leafResFn, resFn = _a.resFn;
    //id=>childrenList
    var childrenMap = new Map();
    arr.forEach(function (item) {
        var children = childrenMap.get(item[parentIdField]);
        children
            ? children.push(item)
            : childrenMap.set(item[parentIdField], [item]);
    });
    //深度
    var layer = 0;
    var dp = function (nodes) {
        return nodes.map(function (item) {
            var children = childrenMap.get(item[idField]);
            if (children) {
                layer++;
                item[childrenField] = dp(children);
                layer--;
            }
            // 生成叶子结点
            if (!children && leafResFn)
                item = leafResFn(item, layer);
            // 生成节点
            return resFn ? resFn(item, layer) : item;
        });
    };
    var nodesArr = arr.filter(function (item) { return item[parentIdField] === rootId; });
    return dp(nodesArr);
}
export function findNodesByKey(list, key, option) {
    //深拷贝防止改变源数据
    list = deepClone(list);
    if (!key)
        return list;
    var defaultOption = {
        nameField: "title",
        childrenField: "children",
    };
    option = __assign(__assign({}, defaultOption), option);
    var _a = option, nameField = _a.nameField, childrenField = _a.childrenField;
    var dp = function (layerList) {
        return layerList.filter(function (item) {
            var children = item[childrenField] && dp(item[childrenField]);
            item[childrenField] = (children === null || children === void 0 ? void 0 : children.length) ? children : undefined;
            return (children === null || children === void 0 ? void 0 : children.length) || item[nameField].includes(key);
        });
    };
    return dp(list);
}
export function isTreeNode(list, key, option) {
    var defaultOption = {
        idField: "key",
        childrenField: "children",
    };
    option = __assign(__assign({}, defaultOption), option);
    var _a = option, idField = _a.idField, childrenField = _a.childrenField;
    var dp = function (layerList) {
        return !!layerList.find(function (item) {
            return item[idField] === key || (item[childrenField] && dp(item[childrenField]));
        });
    };
    return dp(list);
}
//# sourceMappingURL=tree.js.map